<?php
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}//report_do_report_end

$plugins->add_hook("report_do_report_end", "advreports_reporthook");
$plugins->add_hook("warnings_do_warn_start", "advreports_warninghook");

function advreports_info(){
	return array(
		"name"			=> "Zaawansowany system zgłoszeń i ostrzeżeń",
		"description"	=> "Zaawansowany system zgłoszeń i ostrzeżeń. Tworzy nowe tematy na forum o raportach lub ostrzeżeniach.",
		"website"		=> "http://mybbmods.net",
		"author"		=> "MyBB Mods",
		"authorsite"	=> "http://mybbmods.net",
		"version"		=> "1.0",
		"guid" 			=> "2aa38d59e42a57c4c911701d27cb2dad",
		"compatibility" => "16*"
	);
}
function advreports_activate(){
	global $db, $mybb;
	$db->query("INSERT INTO `".TABLE_PREFIX."settinggroups` (`name`, `title`, `description`, `disporder`, `isdefault`) VALUES
('advreports', 'Advanced Reports and Warnings', 'These are the settings for advanced reports and warnings', 0, 0);");
	$gid = $db->insert_id();
	$db->query("INSERT INTO `".TABLE_PREFIX."settings` (`name`, `title`, `description`, `optionscode`, `value`, `disporder`, `isdefault`, `gid`) VALUES
('advreports_warningboard', 'ID działów dla ostrzeżeń', 'ID działów w których ma się tworzyć temat z informacją o ostrzeżeniu Wpisz 0 aby wyłączyć.', 'text', '3', 4, 0, {$gid}),
('advreports_reportmessage', 'Treść tematu o raporcie', 'Wpisz treść tematu o raporcie. Użyj {reporter} aby wyświetlić nick osoby zgłaszającej, {op} by wyświetlić nazwę autora raportowanej wiadomości, {reason} aby pokazać powód, {thread} aby pokazać nazwę tematu z raportowaną wiadomością, {tid} aby wyświetlić ID tematu, {pid} by wyświetlić ID raportowanego postu, {post} aby wyświetlić treść raportowanej wiadomośći i {forum} aby wyświetlić nazwę działu w którym znajduje się raportowana wiadomość.', 'textarea', '{reporter} zgłosił post.\r\n\r\nPowód:\r\n[quote]\r\n{reason}\r\n[/quote]\r\n\r\nTytuł: {title}\r\nDział: {forum}\r\nWysłane przez: {op}\r\n\r\nTreść postu:\r\n[quote]\r\n{post}\r\n[/quote]', 3, 0, {$gid}),
('advreports_reportsubject', 'Nazwa tematu', 'Wpisz nazwę dla nowego tematu o raporcie. Użyj {reporter} aby wyświetlić autora raportowanej wiadomości' 'i {op} aby wyświetlić osobę zgłąszającą.', 'text', '{op} - został zgłoszony przez {reporter}', 2, 0, {$gid}),
('advreports_reportboard', 'ID działów dla raportu', 'ID działów w których ma się tworzyć temat z informacją o raporcie. Wpisz 0 aby wyłączyć.', 'text', '2', 1, 0, {$gid}),
('advreports_warningsubject', 'Nazwa tematu', 'Wpisz nazwę dla nowego tematu o ostrzeżeniu. Użyj {reporter} aby wyświetlić który użytkownik przyznał ostrzeżenie' 'i {user} aby wyświetlić użytkownika który otrzymał ostrzeżenie', 'text', '{user} - dostał ostrzeżenie od {reporter}', 5, 0, {$gid}),
('advreports_warningmessage', 'Treść tematu o ostrzeżeniu', 'Wpisz treść tematu o ostrzeżeniu. Użyj {reporter} aby wyświetlić użytkownika który przyznał ostrzeżenie i {user} by wyświetlić użytkownika którzy otrzymał ostrzeżenie, {notes} by pokazać notatki administracyjne i {reason} aby wyświetlić powód ostrzeżenia.', 'textarea', '{reporter} przyznał ostrzeżenie.\r\n\r\nPowód:\r\n[quote] {reason} [/quote] \r\nUżytkownik: {user}\r\nNotatki:\r\n[quote] {notes} [/quote]', 6, 0, {$gid});");
}
function advreports_deactivate(){
	global $db, $mybb;
	$query = $db->simple_select("settinggroups","*","name='advreports'");
	if($db->num_rows($query) == 1){
		$g = $db->fetch_array($query);
		$db->delete_query("settings","gid={$g['gid']}");
		$db->delete_query("settinggroups","gid={$g['gid']}");
	}
}

function advreports_warninghook(){
	global $mybb, $db;
	if(intval($mybb->settings['advreports_warningboard']) > 0){
		require_once MYBB_ROOT."inc/datahandlers/post.php";
		$posthandler = new PostDataHandler("insert");
		$posthandler->action = "thread";
		$new_thread = array(
			"fid" => $mybb->settings['advreports_warningboard'],
			"subject" => advreports_warningformatsubject($mybb->settings['advreports_warningsubject']),
			"message" => advreports_warningformatmessage($mybb->settings['advreports_warningmessage']),
			"ipaddress" => get_ip(),
			"posthash" => md5($mybb->user['uid'].random_str()),
			"uid" => $mybb->user['uid'],
			"username" => $mybb->user['username'],
			"dateline" => TIME_NOW,
			"lastpost" => TIME_NOW,
			"lastposter" => $db->escape_string($mybb->user['username']),
			"lastposteruid" => $mybb->user['uid'],
			"views" => 1,
			"visible" => "1",
			"icon" => "2",
		);
		$new_thread['options'] = array(
			"signature" => 0,
			"disablesmilies" => 1
		);
		$posthandler->set_data($new_thread);
		$posthandler->set_validated(true);
		$thread_info = $posthandler->insert_thread();
	}
}

function advreports_reporthook(){
	global $mybb, $db;
	if(intval($mybb->settings['advreports_reportboard']) > 0){
		$query = $db->simple_select("posts", "*", "`pid`=".intval($mybb->input['pid']));
		if($db->num_rows($query) == 1){
		require_once MYBB_ROOT."inc/datahandlers/post.php";
			$posthandler = new PostDataHandler("insert");
			$posthandler->action = "thread";
			$new_thread = array(
				"fid" => $mybb->settings['advreports_reportboard'],
				"subject" => advreports_reportformatsubject($mybb->settings['advreports_reportsubject']),
				"message" => advreports_reportformatmessage($mybb->settings['advreports_reportmessage']),
				"ipaddress" => get_ip(),
				"posthash" => md5($mybb->user['uid'].random_str()),
				"uid" => $mybb->user['uid'],
				"username" => $mybb->user['username'],
				"dateline" => TIME_NOW,
				"lastpost" => TIME_NOW,
				"lastposter" =>  $db->escape_string($mybb->user['username']),
				"lastposteruid" => $mybb->user['uid'],
				"views" => 1,
				"visible" => "1",
				"icon" => "2",
			);
			$new_thread['options'] = array(
				"signature" => 0,
				"disablesmilies" => 1
			);
			$posthandler->set_data($new_thread);
			$posthandler->set_validated(true);
			$thread_info = $posthandler->insert_thread();
		}
	}
}

function advreports_warningformatsubject($subject){
	global $db, $mybb;
	$user = $db->simple_select("users","*","uid={$mybb->input['uid']}");
	$u = $db->fetch_array($user);
	$subject = str_replace("{reporter}",$mybb->user['username'],$subject);
	$subject = str_replace("{user}",$u['username'],$subject);
	return $subject;
}

function advreports_warningformatmessage($message){
	global $db, $mybb;

	$op = $db->simple_select("users","*","uid={$mybb->input['uid']}");
	$o = $db->fetch_array($op);
	/*	{reporter} for the warning giver's username, 
		{user} for the warning reciever, 
		{notes} for administrative notes, and 
		{reason} for the reason.*/
	$message = str_replace("{reporter}","[url={$mybb->settings['bburl']}/".get_profile_link($mybb->user['uid'])."]{$mybb->user['username']}[/url]",$message);
	$message = str_replace("{user}","[url={$mybb->settings['bburl']}/".get_profile_link($o['uid'])."]{$o['username']}[/url]",$message);
	if($mybb->input['type'] == "custom"){
		$message = str_replace("{reason}",$db->escape_string(htmlspecialchars_uni($mybb->input['custom_reason'])),$message);
	}else{
		$query = $db->simple_select("warningtypes","*","tid={$mybb->input['type']}");
		if($db->num_rows($query) == 1){
			$w = $db->fetch_array($query);
			$message = str_replace("{reason}",$db->escape_string(htmlspecialchars_uni($w['title'])),$message);
		}else{
			$message = str_replace("{reason}",$db->escape_string(htmlspecialchars_uni('unknown')),$message);
		}
	}
	$message = str_replace("{notes}",$db->escape_string(htmlspecialchars_uni($mybb->input['notes'])),$message);
	$message = str_replace("&amp;","&",$message);
	return $message;
}

function advreports_reportformatsubject($subject){
	global $db, $mybb;

	$post = $db->simple_select("posts","*","pid={$mybb->input['pid']}");
	$p = $db->fetch_array($post);

	$op = $db->simple_select("users","*","uid={$p['uid']}");
	$o = $db->fetch_array($op);

	$subject = str_replace("{op}",$o['username'],$subject);
	$subject = str_replace("{reporter}",$mybb->user['username'],$subject);
	return $subject;
}

function advreports_reportformatmessage($message){
	global $db, $mybb;

	$post = $db->simple_select("posts","*","pid={$mybb->input['pid']}");
	$p = $db->fetch_array($post);

	$op = $db->simple_select("users","*","uid={$p['uid']}");
	$o = $db->fetch_array($op);

	$forum = $db->simple_select("forums","*","fid={$p['fid']}");
	$f = $db->fetch_array($forum);

	$message = str_replace("{reporter}","[url={$mybb->settings['bburl']}/".get_profile_link($mybb->user['uid'])."]{$mybb->user['username']}[/url]",$message);
	$message = str_replace("{op}","[url={$mybb->settings['bburl']}/".get_profile_link($o['uid'])."]{$o['username']}[/url]",$message);
	$message = str_replace("{reason}",$db->escape_string(htmlspecialchars_uni($mybb->input['reason'])),$message);
	$message = str_replace("{title}","[url={$mybb->settings['bburl']}/showthread.php?tid={$p['tid']}&pid={$p['pid']}#pid{$p['pid']}]".$p['subject']."[/url]",$message);
	$message = str_replace("{tid}",$p['tid'],$message);
	$message = str_replace("{pid}",$p['pid'],$message);
	$message = str_replace("{post}",$p['message'],$message);
	$message = str_replace("{fid}",$p['fid'],$message);
	$message = str_replace("{forum}","[url={$mybb->settings['bburl']}/".get_forum_link($f['fid'])."]{$f['name']}[/url]",$message);
	$message = str_replace("&amp;","&",$message);
	return $message;
}
?>